// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/Color.hpp"
#include "display/Texture.hpp"

namespace Dawn {
  struct UIQuad {
    glm::mat4 transform;
    glm::vec4 quad;
    glm::vec4 uv;
    struct Color color;
    std::shared_ptr<Texture> texture;

    UIQuad(
      const glm::mat4 transform,
      const glm::vec4 quad,
      const glm::vec4 uv,
      const struct Color color,
      const std::shared_ptr<Texture> texture
    ) :
      transform(transform),
      quad(quad),
      uv(uv),
      color(color),
      texture(texture)
    {

    }
  };
}