// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "ui/UIComponent.hpp"

namespace Dawn {
  class UIRectangle final : public UIComponent {
    protected:
      std::vector<struct UIQuad> getSelfQuads(
        const glm::mat4 transform
      ) override;

    public:
      struct Color color = COLOR_WHITE;
      std::shared_ptr<Texture> texture = nullptr;
      glm::vec2 size = glm::vec2(32, 32);
      glm::vec4 uv = glm::vec4(0,0,1,1);
  };
}