// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/Shader.hpp"

namespace Dawn {
  struct TestStruct {
    struct Color first;
    glm::vec3 random;
    float_t padded;
    struct Color second;
  };
  
  struct UIShaderData {
    glm::mat4 projection;
    glm::mat4 view;
    glm::mat4 model;
    struct TestStruct test;
  };

  class UIShader : public Shader<UIShaderData> {
    protected:
      void getStages(
        const enum ShaderOpenGLVariant variant,
        const struct UIShaderData *rel,
        std::vector<std::shared_ptr<ShaderStage>> &stages,
        std::vector<struct ShaderParameter> &parameters,
        std::vector<struct IShaderStructure> &structures
      ) override;
  };
}